/*
3D Mesh Editer via "A Simple Approach to Interactive Free-Form 
Shape Deformations" 
Copyright:(c) Shin Yoshizawa, 2002
E-mail: shin.yoshizawa@mpi-sb.mpg.de
URL: http://www.mpi-sb.mpg.de/~shin
Affiliation: Max-Planck-Institut fuer Informatik: Computer Graphics Group 
 Stuhlsatzenhausweg 85, 66123 Saarbruecken, Germany
 Phone +49 681 9325-414 Fax +49 681 9325-499 

 All right is reserved by Shin Yoshizawa.
This java program and sources are allowed for only primary user of 
research and educational purposes. Don't use secondary: copy, distribution, 
diversion, business purpose, and etc.. 
 */
import java.awt.*;
import java.applet.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
public class AnisotropicMetric{
  double a00 = 0.0;
  double a01 = 0.0;
  double a02 = 0.0;
  double a10 = 0.0;
  double a11 = 0.0;
  double a12 = 0.0;
  double a20 = 0.0;
  double a21 = 0.0;
  double a22 = 0.0;
  double x3=0.0;
  double y3=0.0;
  double z3=0.0;
  double dist1=0.0;double dist2=0.0;double dist3=0.0;
  ControlPoint me=null;
  public AnisotropicMetric(ControlPoint dcp){
    me=dcp;
  }
  public AnisotropicMetric(){
    
  }
  
  public double AnisotropicDistance(Point3d inX,Point3d inY){
    double xx = inY.x - inX.x;
    double yy = inY.y - inX.y;
    double zz = inY.z - inX.z;
    if(dist1==0.0||dist2==0.0||dist3==0.0){
      return Math.sqrt(xx*xx + yy*yy+ zz*zz);    
    }
    double fx = a00*xx + a01*yy + a02*zz;
    double fy = a10*xx + a11*yy + a12*zz;
    double fz = a20*xx + a21*yy + a22*zz;
    //double distance = (Math.pow(dist1,me.alpha)/(2.0*me.epsilon*me.epsilon));
    //return Math.sqrt(Math.abs(fx*fx*distance + fy*fy +fz*fz));
  
      // Math.exp((-(Math.pow(length,now.alpha))/(2.0*now.epsilon*now.epsilon)));
    return Math.sqrt(Math.abs(fx*fx/(10.0*dist1) + fy*fy +fz*fz));
  }
  public void InitMetric(Point3d AniXYZ,Point3d evaP,Point3d minO){
    
    double x1 = AniXYZ.x - evaP.x;
    double y1 = AniXYZ.y - evaP.y;
    double z1 = AniXYZ.z - evaP.z;
    dist1 = Math.sqrt(x1*x1+y1*y1+z1*z1); 
    if(dist1!=0.0){
      x1 /= dist1;
      y1 /= dist1;
      z1 /= dist1;
    }
    x3 = evaP.x - minO.x;
    y3 = evaP.y - minO.y;
    z3 = evaP.z - minO.z;
    dist3 = Math.sqrt(x3*x3+y3*y3+z3*z3);
    if(dist3!=0.0){
      x3 /= dist3;
      y3 /= dist3;
      z3 /= dist3;
    }
    double x2 = (y1*z3 - y3*z1);
    double y2 = (z1*x3 - z3*x1);
    double z2 = (x1*y3 - x3*y1);
    dist2 = Math.sqrt(x2*x2+y2*y2+z2*z2);
    if(dist2!=0.0){
      x2 /= dist2;
      y2 /= dist2;
      z2 /= dist2;
    }
    
    a00 = x1;
    a01 = y1;
    a02 = z1;
    a10 = x2;
    a11 = y2;
    a12 = z2;
    a20 = x3;
    a21 = y3;
    a22 = z3;
  }
  public double Distance(Point3d in1,Point3d in2){
    return Math.sqrt((((in1.x-in2.x)*(in1.x-in2.x))
		      +((in1.y-in2.y)*(in1.y-in2.y))
		      +((in1.z-in2.z)*(in1.z-in2.z))));
		      
  }
   
}
