/*
3D Mesh Editer via "A Simple Approach to Interactive Free-Form 
Shape Deformations" 
Copyright:(c) Shin Yoshizawa, 2002
E-mail: shin.yoshizawa@mpi-sb.mpg.de
URL: http://www.mpi-sb.mpg.de/~shin
Affiliation: Max-Planck-Institut fuer Informatik: Computer Graphics Group 
 Stuhlsatzenhausweg 85, 66123 Saarbruecken, Germany
 Phone +49 681 9325-414 Fax +49 681 9325-499 

 All right is reserved by Shin Yoshizawa.
This java program and sources are allowed for only primary user of 
research and educational purposes. Don't use secondary: copy, distribution, 
diversion, business purpose, and etc.. 
 */
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;
public class ControlInterface{

  
  int numberV=0;
  ControlPoint pHead=null;
  ControlPoint pTail=null;
   
  Point3d[] mynormal=null;
  Vector3f[] mynormalnormal=null;
  Point3d[] mynormal2=null;
  Vector3f[] mynormalnormal2=null;
  LineArray myline=null;
  LineArray myline2=null;
  public ControlInterface(){
    initlist();
  }
  public void initlist(){
    pHead = new ControlPoint();
    pTail = new ControlPoint();
    pHead.next = pTail;
    pTail.back = pHead;
    numberV=0;
  }
  private double Distance(Point3d in1,Point3d in2){
    return Math.sqrt((((in1.x-in2.x)*(in1.x-in2.x))
		      +((in1.y-in2.y)*(in1.y-in2.y))
		      +((in1.z-in2.z)*(in1.z-in2.z))));
    
  }
  public void setEAll(double dv){
    ControlPoint now = pHead;
    while(next(now)!=pTail){
      now = next(now);
      now.epsilon = dv;
    }
  }
  public void setAAll(double dv){
    ControlPoint now = pHead;
    while(next(now)!=pTail){
      now = next(now);
      now.alpha = dv;
    }
  }
  public void setGAll(double dv){
    ControlPoint now = pHead;
    while(next(now)!=pTail){
      now = next(now);
      now.gamma = dv;
    }
  }
  
  public ControlPoint getCP(int i){
    ControlPoint now = pHead;
    while(next(now)!=pTail){
      now = next(now);
      if(now.ID==i)return now;
    }
    return null;
  }
  public void lineclear(){
    mynormal=null;
    mynormalnormal=null;
    myline=null;
    myline2=null;
    mynormal = new Point3d[2*numberV];
    mynormalnormal = new Vector3f[2*numberV];
    mynormal2 = new Point3d[2*numberV];
    mynormalnormal2 = new Vector3f[2*numberV];
    
    myline = new LineArray(2*numberV,GeometryArray.COORDINATES
			   | GeometryArray.NORMALS);
    myline.setCapability(Geometry.ALLOW_INTERSECT);
    myline.setCapability(LineArray.ALLOW_COORDINATE_WRITE);
    myline.setCapability(LineArray.ALLOW_NORMAL_WRITE); 
    myline2 = new LineArray(2*numberV,GeometryArray.COORDINATES
			   | GeometryArray.NORMALS);
    myline2.setCapability(Geometry.ALLOW_INTERSECT);
    myline2.setCapability(LineArray.ALLOW_COORDINATE_WRITE);
    myline2.setCapability(LineArray.ALLOW_NORMAL_WRITE); 
    ControlPoint now = pHead;
    int i=0;
    while(next(now)!=pTail){
      now = next(now);
      mynormal[2*i] = now.point;
      mynormal[2*i+1] = now.Ipoint;
      mynormalnormal[2*i] = new Vector3f((float)(now.point.x),
					 (float)(now.point.y),
					 (float)(now.point.z));
      mynormalnormal[2*i+1] = new Vector3f((float)(now.Ipoint.x),
					   (float)(now.Ipoint.y),
					   (float)(now.Ipoint.z));
      mynormal2[2*i] = now.point;
      mynormal2[2*i+1] = now.anisotropy;
      mynormalnormal2[2*i] = new Vector3f((float)(now.point.x),
					 (float)(now.point.y),
					 (float)(now.point.z));
      mynormalnormal2[2*i+1] = new Vector3f((float)(now.anisotropy.x),
					   (float)(now.anisotropy.y),
					   (float)(now.anisotropy.z));
     
      i++;
    }
    myline.setCoordinates(0,mynormal);
    myline.setNormals(0,mynormalnormal);
    myline2.setCoordinates(0,mynormal2);
    myline2.setNormals(0,mynormalnormal2);
  }
    private ControlPoint next(ControlPoint now){
      return (now.next);
    }
   private ControlPoint back(ControlPoint now){
      return (now.back);
    }
    
  public ControlPoint AppendCP(int numV,double dx,double dy,double dz,ControlPoint dVTail)
    {
      ControlPoint now = new ControlPoint(numberV,dx,dy,dz,numV);
      ControlPoint dummy = dVTail.back;
      now.next = dVTail;
      dVTail.back = now;
      now.back = dummy;
      dummy.next =now;
      numberV++;
      lineclear();
      return now;
    }
  public void changeCPpoint(ControlPoint dCP,Point3d newposi){
    dCP.point.x = newposi.x;
    dCP.point.y = newposi.y;
    dCP.point.z = newposi.z;
    
    
    mynormal[2*dCP.ID] = dCP.point;
     
    
    mynormalnormal[2*dCP.ID] = new Vector3f((float)(dCP.point.x),
				     (float)(dCP.point.y),
				     (float)(dCP.point.z));
    myline.setCoordinates(0,mynormal);
    myline.setNormals(0,mynormalnormal); 
    mynormal2[2*dCP.ID] = dCP.point;
     
    
    mynormalnormal2[2*dCP.ID] = new Vector3f((float)(dCP.point.x),
				     (float)(dCP.point.y),
				     (float)(dCP.point.z));
    myline2.setCoordinates(0,mynormal2);
    myline2.setNormals(0,mynormalnormal2); 
   
    
  }
   public void changeAnisopointConstXXX(ControlPoint dCP,Point3d newposi){
    double vecX = newposi.x - dCP.point.x;
    double vecY = newposi.y - dCP.point.y;
    double vecZ = newposi.z - dCP.point.z;
    double dist = dCP.AM.x3*vecX + dCP.AM.y3*vecY +dCP.AM.z3*vecZ;
    dCP.anisotropy.x = newposi.x - dist*dCP.AM.x3;
    dCP.anisotropy.y = newposi.y - dist*dCP.AM.y3;
    dCP.anisotropy.z = newposi.z - dist*dCP.AM.z3;
    
    
    mynormal2[2*dCP.ID+1] = dCP.anisotropy;
     
    
    mynormalnormal2[2*dCP.ID+1] = new Vector3f((float)(dCP.anisotropy.x),
				     (float)(dCP.anisotropy.y),
				     (float)(dCP.anisotropy.z));
    myline2.setCoordinates(0,mynormal2);
    myline2.setNormals(0,mynormalnormal2); 
    
  }
  public void changeAnisopointConst(ControlPoint dCP,Point3d newposi){
    double vecX,vecY,vecZ;
    
    vecX = newposi.x - dCP.point.x;
    vecY = newposi.y - dCP.point.y;
    vecZ = newposi.z - dCP.point.z;
    
    double dist = dCP.AM.x3*vecX + dCP.AM.y3*vecY +dCP.AM.z3*vecZ;
    dCP.anisotropy.x = newposi.x - dist*dCP.AM.x3;
    dCP.anisotropy.y = newposi.y - dist*dCP.AM.y3;
    dCP.anisotropy.z = newposi.z - dist*dCP.AM.z3;
    
    
    mynormal2[2*dCP.ID+1] = dCP.anisotropy;
     
    
    mynormalnormal2[2*dCP.ID+1] = new Vector3f((float)(dCP.anisotropy.x),
				     (float)(dCP.anisotropy.y),
				     (float)(dCP.anisotropy.z));
    myline2.setCoordinates(0,mynormal2);
    myline2.setNormals(0,mynormalnormal2); 
    
  }
  
  public void changeAnisopoint(ControlPoint dCP,Point3d newposi){
   
    dCP.anisotropy.x = newposi.x;
    dCP.anisotropy.y = newposi.y;
    dCP.anisotropy.z = newposi.z;
    
    
    mynormal2[2*dCP.ID+1] = dCP.anisotropy;
     
    
    mynormalnormal2[2*dCP.ID+1] = new Vector3f((float)(dCP.anisotropy.x),
				     (float)(dCP.anisotropy.y),
				     (float)(dCP.anisotropy.z));
    myline2.setCoordinates(0,mynormal2);
    myline2.setNormals(0,mynormalnormal2); 
    
  }
  public void changeCPIPpoint(ControlPoint dCP,Point3d newposi){
    dCP.Ipoint.x = newposi.x;
    dCP.Ipoint.y = newposi.y;
    dCP.Ipoint.z = newposi.z;
    
    
    mynormal[2*dCP.ID+1] = dCP.Ipoint;
     
    
    mynormalnormal[2*dCP.ID+1] = new Vector3f((float)(dCP.Ipoint.x),
				     (float)(dCP.Ipoint.y),
				     (float)(dCP.Ipoint.z));
    myline.setCoordinates(0,mynormal);
    myline.setNormals(0,mynormalnormal); 
   
  }
  
}
