/*
3D Mesh Editer via "A Simple Approach to Interactive Free-Form 
Shape Deformations" 
Copyright:(c) Shin Yoshizawa, 2002
E-mail: shin.yoshizawa@mpi-sb.mpg.de
URL: http://www.mpi-sb.mpg.de/~shin
Affiliation: Max-Planck-Institut fuer Informatik: Computer Graphics Group 
 Stuhlsatzenhausweg 85, 66123 Saarbruecken, Germany
 Phone +49 681 9325-414 Fax +49 681 9325-499 

 All right is reserved by Shin Yoshizawa.
This java program and sources are allowed for only primary user of 
research and educational purposes. Don't use secondary: copy, distribution, 
diversion, business purpose, and etc.. 

 */
import java.awt.*;
import java.applet.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
public class ControlPoint{
  Point3d point=null;
  Point3d Vpoint=null;
  Point3d Ipoint=null;
  int targetN;
  int ID=-1;
  int cpstate=1;
  boolean w=true;
  boolean at=true;
  Point3d anisotropy=null;
  int minID=-1;
  AnisotropicMetric AM=null;
  /*
   0: standard control point
   1: virtual control point
   2: constrained standard control point
   3: constrained virtual control point
   */
  
  double alpha=2.0;
  double gamma=1.0;
  double epsilon=0.15;
  double norm=1.0;
  double[] Eweight=null;
  ControlPoint next=null;
  ControlPoint back=null;
  
  public ControlPoint(){
    point = new Point3d(0.0,0.0,0.0);
    Vpoint = new Point3d(0.0,0.0,0.0);
    Ipoint = new Point3d(0.0,0.0,0.0);
    anisotropy = new Point3d(0.0,0.0,0.0);
    //AM = new AnisotropicMetric();
    AM = new AnisotropicMetric(this);
  }
  public void InitAnisoMetric(Point3d minP){
    AM.InitMetric(anisotropy,point,minP);
  }
  
   public ControlPoint(int dID,double dx,double dy,double dz,int dnum){
     point = new Point3d(dx,dy,dz);
     Vpoint = new Point3d(dx,dy,dz);
     Ipoint = new Point3d(dx,dy,dz);
     anisotropy = new Point3d(dx,dy,dz);
     AM = new AnisotropicMetric(this);
     //AM = new AnisotropicMetric();
     
     ID = dID;
     targetN = dnum;
     Eweight = new double[targetN];
   }
   
}
