/*
3D Mesh Editer via "A Simple Approach to Interactive Free-Form 
Shape Deformations" 
Copyright:(c) Shin Yoshizawa, 2002
E-mail: shin.yoshizawa@mpi-sb.mpg.de
URL: http://www.mpi-sb.mpg.de/~shin
Affiliation: Max-Planck-Institut fuer Informatik: Computer Graphics Group 
 Stuhlsatzenhausweg 85, 66123 Saarbruecken, Germany
 Phone +49 681 9325-414 Fax +49 681 9325-499 

 All right is reserved by Shin Yoshizawa.
This java program and sources are allowed for only primary user of 
research and educational purposes. Don't use secondary: copy, distribution, 
diversion, business purpose, and etc.. 

 */
import java.io.*;
import java.applet.Applet;
import java.awt.FlowLayout;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.Hashtable;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.interpolators.*;
import com.sun.image.codec.jpeg.*;

public class JPEGCanvas3D{
  Canvas3D canvas;
  String filename;
  JPEGCodec myencode;
  public JPEGCanvas3D(Canvas3D dcanvas,String dfilename){
    canvas = dcanvas;
    filename = dfilename;
    OutputStream output;
    try{
      canvas.stopRenderer();
      //canvas.repaint();
      Dimension d = canvas.getSize();
      BufferedImage bImage = 
	new BufferedImage(d.width, d.height,BufferedImage.TYPE_INT_ARGB);
      ImageComponent2D imgComp = 
	new ImageComponent2D(ImageComponent2D.FORMAT_RGB,bImage);
      javax.media.j3d.Raster snapshot = new javax.media.j3d.Raster(new Point3f(), javax.media.j3d.Raster.RASTER_COLOR, 0, 0, d.width,d.height, imgComp, null);
      
      canvas.getGraphicsContext3D().readRaster(snapshot);
      BufferedImage bi = snapshot.getImage().getImage();
      output = new BufferedOutputStream(new FileOutputStream
						  (filename));
      
      
      JPEGImageEncoder myjpegencode = myencode.createJPEGEncoder(output,myencode.getDefaultJPEGEncodeParam(bi));
      myjpegencode.encode(bi);
      output.close();
      canvas.startRenderer();
  }catch(IOException e){
		  System.out.println("Error ! IOException in NLSMSimulator.java");
	      
  }
}
}
