/*
3D Mesh Editer via "A Simple Approach to Interactive Free-Form 
Shape Deformations" 
Copyright:(c) Shin Yoshizawa, 2002
E-mail: shin.yoshizawa@mpi-sb.mpg.de
URL: http://www.mpi-sb.mpg.de/~shin
Affiliation: Max-Planck-Institut fuer Informatik: Computer Graphics Group 
 Stuhlsatzenhausweg 85, 66123 Saarbruecken, Germany
 Phone +49 681 9325-414 Fax +49 681 9325-499 

 All right is reserved by Shin Yoshizawa.
This java program and sources are allowed for only primary user of 
research and educational purposes. Don't use secondary: copy, distribution, 
diversion, business purpose, and etc.. 

 */
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class ViewShape3D extends Shape3D{

  int numberV=0;
  int numberF=0;
  public Point3d[] verts;
  public Vector3f[] vertNormal;
  TriangleArray tetra;
  Color3f[] pastel;
  Vector3d ddnormalv3d = new Vector3d(0.0,0.0,0.0);
  Vector3d v1v3d = new Vector3d(0.0,0.0,0.0);
  Vector3d v2v3d = new Vector3d(0.0,0.0,0.0);
  Point3d tmppoint3d1 = new Point3d(0.0,0.0,0.0);
  Point3d tmppoint3d2 = new Point3d(0.0,0.0,0.0);
  Color3f[] mycolor; 
  boolean pastelnormal=true;
  int type=0;

  public ViewShape3D(int id){
    type = id;
    this.setCapability(Shape3D.ALLOW_PICKABLE_READ);
    this.setCapability(Shape3D.ALLOW_PICKABLE_WRITE); 
  }
  public void reNew(int dv,int df){
    numberV = dv;
    numberF = df;
    MemoryAllocation();
  }
  public void setPastelColor(double[] color,int[][] Face){
    int i,j;
    float dummyv=0.0f;
    for(i=0;i<numberF;i++){
       for(j=0;j<3;j++){
	 dummyv = ((float)(color[Face[i][j]]));
	 pastel[(3*i+j)].x = paR(dummyv);
	 pastel[(3*i+j)].y = paG(dummyv);
	 pastel[(3*i+j)].z = paB(dummyv);
       }
    }
  }
  public void setColor(boolean dv){
    pastelnormal = dv;
    if(dv){
      
      //tetra.setColors(0,mycolor);
      tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS| 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ);tetra.setColors(0,mycolor);
      //System.out.println("AAAAAAAAAAAAA");
    }else{
      tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 
      
      tetra.setColors(0,pastel); 
    }
    tetra.setCoordinates(0,verts);
    tetra.setNormals(0,vertNormal);
    this.setGeometry(tetra); 
  }
  
  private void MemoryAllocation(){
    tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
    tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS);
    mycolor = new Color3f[(numberF*3)]; 
    pastel = new Color3f[(numberF*3)];  
    verts = new Point3d[(numberF*3)];
    vertNormal = new Vector3f[(numberF*3)];
    int i=0;
    for(i=0;i<(numberF*3);i++){
      vertNormal[i] = new Vector3f(0.0f,0.0f,0.0f);
      if(type==1){
	mycolor[i] = new Color3f(0.2000f,0.6300f,0.0f);
      }else{
	mycolor[i] = new Color3f(0.2000f,0.6300f,0.7900f);
      }
      verts[i] = new Point3d(0.0,0.0,0.0);
      pastel[i]  = new Color3f(0.0f,0.0f,1.0f);
    }
  }
  public void MakeArrayDataAFTER(){
    tetra.setCoordinates(0,verts);
     if(pastelnormal){
       //tetra.setColors(0,mycolor);
        tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS| 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 
      tetra.setColors(0,mycolor);
      //System.out.println("BBBBBBBBBBBBBBBBBB");
    }else{
       tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 
      tetra.setColors(0,pastel); 
    } 
    tetra.setNormals(0,vertNormal); tetra.setCoordinates(0,verts);
    this.setGeometry(tetra);
  }
  public void MakeArrayData(){
    if(pastelnormal){
      //tetra.setColors(0,mycolor);
       tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 
      //System.out.println("CCCCCCCCCCCCCCCCC");
      tetra.setColors(0,mycolor);
      
    }else{
      tetra = new TriangleArray((numberF*3), TriangleArray.COORDINATES |
			      TriangleArray.NORMALS | 
      			      TriangleArray.COLOR_3);
      tetra.setCapability(Geometry.ALLOW_INTERSECT);
      tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
      tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
      tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
      tetra.setCapability(tetra.ALLOW_COORDINATE_READ); 
      
      tetra.setColors(0,pastel); 
    }
    tetra.setCoordinates(0,verts);
    tetra.setNormals(0,vertNormal);
    
    /*
    tetra.setCapability(Geometry.ALLOW_INTERSECT);
    tetra.setCapability(tetra.ALLOW_COLOR_WRITE);
    tetra.setCapability(tetra.ALLOW_COORDINATE_WRITE); 
    tetra.setCapability(tetra.ALLOW_NORMAL_WRITE); 
    tetra.setCapability(tetra.ALLOW_NORMAL_READ); 
    tetra.setCapability(tetra.ALLOW_COORDINATE_READ); */ 
    this.setGeometry(tetra);
  }
  public void MakeFace(int i,int di,int dj,int dk,Point3d[] point){
    int[] Face = new int[3];
    Face[0] = di;
    Face[1] = dj;
    Face[2] = dk;
    v1v3d.x = ((point[Face[0]]).x - (point[Face[1]]).x);
    v1v3d.y = ((point[Face[0]]).y - (point[Face[1]]).y);
    v1v3d.z = ((point[Face[0]]).z - (point[Face[1]]).z);
    v2v3d.x = ((point[Face[0]]).x - (point[Face[2]]).x);
    v2v3d.y = ((point[Face[0]]).y - (point[Face[2]]).y);
    v2v3d.z = ((point[Face[0]]).z - (point[Face[2]]).z);
    ddnormalv3d.cross(v1v3d, v2v3d);
    ddnormalv3d.normalize();
    int j=0;
 
    for(j=0;j<3;j++){
      verts[(3*i+j)].x = point[Face[j]].x;
      verts[(3*i+j)].y = point[Face[j]].y;
      verts[(3*i+j)].z = point[Face[j]].z;
      
      vertNormal[(3*i+j)].x = ((float)(ddnormalv3d.x));
      vertNormal[(3*i+j)].y = ((float)(ddnormalv3d.y));
      vertNormal[(3*i+j)].z = ((float)(ddnormalv3d.z));
    }
    
  }
  private float paG(float dv){
    if(dv >0.5){
      return ((float)(-2.0*dv + 2.0));
    }else{
    return 1.0f;
    }
  }

  private float paR(float dv){
    if(dv <0.5){
      return ((float)(2.0*dv));
  }else{
    return 1.0f;
  }
  }
  private float paB(float dv){
    if(dv <0.5){
      return ((float)(-2.0*dv + 1.0));
    }else{
      return ((float)(2.0*dv - 1.0));
    }
  }
  
}
